
;CodeVisionAVR C Compiler V3.10 Advanced
;(C) Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Debug
;Chip type              : ATtiny26
;Program type           : Application
;Clock frequency        : 8,000000 MHz
;Memory model           : Tiny
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 32 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': Yes
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: Yes
;Enhanced function parameter passing: Yes
;Automatic register allocation for global variables: On
;Smart register allocation: Off

	#define _MODEL_TINY_

	#pragma AVRPART ADMIN PART_NAME ATtiny26
	#pragma AVRPART MEMORY PROG_FLASH 2048
	#pragma AVRPART MEMORY EEPROM 128
	#pragma AVRPART MEMORY INT_SRAM SIZE 128
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E

	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x00DF
	.EQU __DSTACK_SIZE=0x0020
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	RCALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _temp_8=R4
	.DEF _flag_bat=R5
	.DEF _flag_process=R6
	.DEF _flag_out=R7
	.DEF _c_pausa=R8
	.DEF _c_pausa_msb=R9
	.DEF _c_switch=R10
	.DEF _c_switch_msb=R11

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

;GLOBAL REGISTER VARIABLES INITIALIZATION
__REG_VARS:
	.DB  0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0


__GLOBAL_INI_TBL:
	.DW  0x08
	.DW  0x04
	.DW  __REG_VARS*2

_0xFFFFFFFF:
	.DW  0

#define __GLOBAL_INI_TBL_PRESENT 1

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,__CLEAR_SRAM_SIZE
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x80

	.CSEG
;/*****************************************************
;    3-IN 2-OUT
;      00.01
;        26.03.17
;      tiny26
;       
;     1 
;*****************************************************/
;//   
;    #include <tiny26.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_mask=0x18
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x18
	.SET power_ctrl_reg=mcucr
	#endif
;    #include <lib_macro_V_03.c>
;//    
;//    :000_03
;//      :27.02.15
;//
;//	#include <lib_macro_V_03.c>
;//******************
;// 
;    #asm
	//	.equ    TCCR0    =$33
	//	.def    r_temp   =r16   // 
; 0000 000B     #endasm
;
;// 
;	#define WDR #asm("wdr")	    // 
;    #define CLI #asm("cli")     // 
;    #define SEI #asm("sei")     // 
;    #define TRUE 1              //   
;    #define FALS 0              //   
;    #define ZERO 0              //
;    #define CLEAR 0             //
;    #define OFF 0               //
;    #define ON 1                //
;// 
;    #define EEP_SAVE 0x00       //   
;    #define FERST_SET 0x09       //   
;    #define MAX_PAUSA 30000      //   
;    #define MAX_SWITCH_OUT 5  //    
;    #define IN_SWITCH 2600       //   
;
;//END 
;//******************
;//  
;    //#pragma regalloc-   //    
;	//  - ; d - ; f - ;
;	//   R2 
;	/*
;        //bit f_b_    = FALS;                     //bit 0 -   
;        //bit f_b_    = FALS;                     //bit 1 -  
;        //bit f_b_    = FALS;                     //bit 2 -   
;        //bit f_b_    = FALS;                     //bit 3 -  
;        //bit f_b_    = FALS;                     //bit 4 -   
;        //bit f_b_    = FALS;                     //bit 5 -   
;		//bit f_b_    = FALS;                     //bit 6 -   
;        //bit f_b_    = FALS;                     //bit 7 -  
;	*/
;    // 8  (unsigned char)
;       // register unsigned char f_paisa = OFF;        //    
;        unsigned char temp_8 = CLEAR;              //  8 
;        unsigned char flag_bat = OFF;             //  
;        unsigned char flag_process = OFF;             //  
;        unsigned char flag_out = OFF;             //  
;
;    // 16  (unsigned int)
;        //register unsigned int d_nul_c = 0;              //   
;        unsigned int c_pausa = CLEAR;              // 
;        unsigned int c_switch = CLEAR;              //  
;
;    // 32  (unsigned long int)
;        //unsigned long int d_dat = ZERO;
;
;    // 32  (float)
;		//float int d_cod = ZERO;                             //
;
;    //#pragma regalloc+   //    
;//END  
;//******************
;
;//
;//     ****************
;    #include <lib_EEP_ATtiny_26_V_01.c>
;/*       ATtiny 26******************
;	    :00.01
;	      :22.03.17
;	#include <lib_EEP_ATtiny_26_V_01.c>
;	eepr_in (data_eepr, adr_eepr);                      //  
;	eepr_out (adr_eepr);                                //  
;***********************************************************************/
;
;//  
;/* 	data_eepr	-     (8 )
;	adr_eepr	-      (8 )*/
;
;	void eepr_in (unsigned char data_eepr, unsigned char adr_eepr) {
; 0000 000F void eepr_in (unsigned char data_eepr, unsigned char adr_eepr) {

	.CSEG
_eepr_in:
; .FSTART _eepr_in
;		while (EECR & (1<<EEWE)); 			//   
	ST   -Y,R26
;	data_eepr -> Y+1
;	adr_eepr -> Y+0
_0x3:
	SBIC 0x1C,1
	RJMP _0x3
;		EEAR = adr_eepr; 					//   -  
	LD   R30,Y
	OUT  0x1E,R30
;   		EEDR = data_eepr;    				// 
	LDD  R30,Y+1
	OUT  0x1D,R30
;   		EECR |= (1<<EEMWE);  				//   
	SBI  0x1C,2
;   		EECR |= (1<<EEWE);   				//   
	SBI  0x1C,1
;  		return;
	ADIW R28,2
	RET
;	} // END   
; .FEND
;
;//  
;/*	adr_eepr	-      (8 )*/
;
;	unsigned char eepr_out (unsigned char adr_eepr) {
_eepr_out:
; .FSTART _eepr_out
;		while (EECR & (1<<EEWE));  			//   
	ST   -Y,R26
;	adr_eepr -> Y+0
_0x6:
	SBIC 0x1C,1
	RJMP _0x6
;		EEAR = adr_eepr; 					//   -  
	LD   R30,Y
	OUT  0x1E,R30
;   		EECR = (1<< EERE);   				//   
	LDI  R30,LOW(1)
	OUT  0x1C,R30
;		return (EEDR);
	IN   R30,0x1D
	ADIW R28,1
	RET
;	} //END   
; .FEND
;
;// END      
;//   ********************
;    #include <lib_batt_one_03.c>
;/*   ************************************
;	:  000.03
;	:    05.02.15
;	unsigned char bat_pusch_one (void); //   
;	#include <lib_batt_one_03.c>
;***********************************************************************/
;
;    unsigned char bat_pusch_one (void){
; 0000 0011 unsigned char bat_pusch_one (void){
_bat_pusch_one:
; .FSTART _bat_pusch_one
;
;	// 
;        #define PAUSA_LINE  	50        	//  
;        #define PAUSA_BAT   	50        	//  
;        #define PORT        	PINA.7     	//   
;		#define BAT_ON			1			//  
;		#define BAT_OFF			0			//  
;		#define FLAG_BAT_ON		1			//   
;		#define FLAG_BAT_OFF	0			//   
;
;    //
;                unsigned char   bat_numer       = BAT_OFF;    	//  
;        static  unsigned char   flag_bat_on     = ZERO;    	//    
;        static  unsigned char   flag_bat        = FLAG_BAT_OFF; //   
;        static  unsigned int    schet_flag_bat  = ZERO;    	//    
;
;        // 
;        if (!(flag_bat)){                           		//    
	ST   -Y,R16
;	bat_numer -> R16
	LDI  R16,0
	LDS  R30,_flag_bat_S0000002000
	CPI  R30,0
	BRNE _0x9
;            if (PORT) flag_bat = FLAG_BAT_ON;    			//  
	SBIS 0x19,7
	RJMP _0xA
	LDI  R30,LOW(1)
	STS  _flag_bat_S0000002000,R30
;            if (flag_bat){									//  
_0xA:
	LDS  R30,_flag_bat_S0000002000
	CPI  R30,0
	BREQ _0xB
;                if ((++flag_bat_on) >= PAUSA_BAT){      	//  
	LDS  R26,_flag_bat_on_S0000002000
	SUBI R26,-LOW(1)
	STS  _flag_bat_on_S0000002000,R26
	CPI  R26,LOW(0x32)
	BRLO _0xC
;                    flag_bat_on = ZERO;               		//   
	LDI  R30,LOW(0)
	STS  _flag_bat_on_S0000002000,R30
;                    bat_numer = BAT_ON;                		//   
	LDI  R16,LOW(1)
;                }
;            }
_0xC:
;            else flag_bat_on = ZERO;                  		//   
	RJMP _0xD
_0xB:
	LDI  R30,LOW(0)
	STS  _flag_bat_on_S0000002000,R30
;        }
_0xD:
;        else{ 												//    
	RJMP _0xE
_0x9:
;            if ((++schet_flag_bat) >= PAUSA_LINE){      	//  
	LDI  R26,LOW(_schet_flag_bat_S0000002000)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,50
	BRLO _0xF
;                flag_bat = FLAG_BAT_OFF;                	//   
	LDI  R30,LOW(0)
	STS  _flag_bat_S0000002000,R30
;                schet_flag_bat = ZERO;                 		//  
	STS  _schet_flag_bat_S0000002000,R30
	STS  _schet_flag_bat_S0000002000+1,R30
;            }
;        }
_0xF:
_0xE:
;        return (bat_numer);
	MOV  R30,R16
	LD   R16,Y+
	RET
;    } //END  
; .FEND
;// 
;
;//
;void main(void)
; 0000 0015 {
_main:
; .FSTART _main
; 0000 0016 // 
; 0000 0017     #include <lib_nastroyki_ATtiny_26.c>
;//*****************************************************
;//  ATtiny 26
;//	:01.001
;//		:26.03.17
;//
;//#interapt <lib_nastroyki_ATtiny_26.c>
;//*****************************************************
;//
;//
;//  
;//****************************************************************
;/*
;		#define I  7 //  
;		#define T  6 //  
;		#define H  5 //  
;		#define S  4 // 
;		#define V  3 //   
;		#define N  2 //  
;		#define Z  1 // 
;		#define C  0 // 
;
;	SREG = (0<<I)|(0<<T)|(0<<H)|(0<<S)|(0<<V)|(0<<N)|(0<<Z)|(0<<C); // 
;*/
;	//**END*  ********************************
;
;//   
;//**************************************************************
;/*
;	//       
;
;	//OSCCAL = 0x00 ; //    
;*/
;	//**END*   ******************
;
;//   
;//********************************************************************
;//     RAM - ATtiny 26 RAMEND =$DF
;
;	SP = 0xDF; //   
	LDI  R30,LOW(223)
	OUT  0x3D,R30
;
;	//**END*   **************************
;
;//   (1 - ; 0 - )
;//*****************************************************
;
;	// A (8 )
;	//*****************************************************
;
;		#define PA7  7 //11  (ADC6/AIN1)      ()
;		#define PA6  6 //12  (ADC5/AIN0)      ()
;		#define PA5  5 //13  (ADC4)           ()
;		#define PA4  4 //14  (ADC3)           ()
;		#define PA3  3 //17  (AREF)           ()
;		#define PA2  2 //18  (ADC2)           ()
;		#define PA1  1 //19  (ADC1)           ()
;		#define PA0  0 //20  (ADC0)           ()
;
;	PORTA  = (0<<PA7)|(0<<PA6)|(0<<PA5)|(0<<PA4)|(0<<PA3)|(0<<PA2)|(0<<PA1)|(0<<PA0);   // 
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;	DDRA   = (0<<PA7)|(0<<PA6)|(0<<PA5)|(1<<PA4)|(1<<PA3)|(1<<PA2)|(1<<PA1)|(1<<PA0);   //  
	LDI  R30,LOW(31)
	OUT  0x1A,R30
;	//PINA -   
;
;	//  (8 )
;	//*****************************************************
;
;		#define PB7  7 //10  (ADC10/RESET)    (reset)
;		#define PB6  6 //9   (ADC9/INT0/T0)   ()
;		#define PB5  5 //8   (ADC8/XTAL2)     ()
;		#define PB4  4 //7   (ADC7/XTAL1)     ()
;		#define PB3  3 //4   (OC1B)           ()
;		#define PB2  2 //3   (SCK/SCL/OC1Bi)  ()
;		#define PB1  1 //2   (MISO/DO/OC1A)   ()
;		#define PB0  0 //1   (MOSI/SDA/OC1Ai) ()
;
;	PORTB  = (0<<PB7)|(0<<PB6)|(0<<PB5)|(0<<PB4)|(0<<PB3)|(0<<PB2)|(0<<PB1)|(0<<PB0);   // 
	LDI  R30,LOW(0)
	OUT  0x18,R30
;	DDRB   = (0<<PB7)|(0<<PB6)|(0<<PB5)|(1<<PB4)|(1<<PB3)|(1<<PB2)|(1<<PB1)|(1<<PB0);   //  
	LDI  R30,LOW(31)
	OUT  0x17,R30
;	//PINB -   
;
;	//**END****************************************************
;
;//
;//*************************************************************
;	//  0
;	//*************************************************************
;/*
;        #define CSO0  0 //  
;		#define CSO1  1 //  
;		#define CSO2  2 //  
;        #define PSR0  3 //    1       ...
;		    // 	  CSOx	
;    		//	000             	
;    		//	001             	 0
;   		    //  010             	 8
;   		    //  011             	 64
;    		//	100             	 256
;    		//	101             	 1024
;    		//	110             	   
;    		//	111             	   
;
;	TCCR0 = (0<<PSR0 )|(0<<CSO2)|(0<<CSO1)|(0<<CSO0);  //   0
;	TCNT0 = 0; 				//   0
;*/
;
;	//  1
;	//*************************************************************
;/*
;		#define COM1A1 7 //   
;		#define COM1A0 6 //   
;		#define COM1B1 5 //   
;		#define COM1B0 4 //   
;		#define FOC1A  3 //   
;		#define FOC1B  2 //   
;		#define PWM1A  1 //   
;		#define PWM1B  0 //   
;
;	TCCR1A	= (0<<COM1A1)|(0<<COM1A0)|(0<<COM1B1)|(0<<COM1B0)|(0<<FOC1A)|(0<<FOC1B)|(0<<PWM1A)|(0<<PWM1B); //  ...
;
;		#define CTC1  7 //       OCR1
;		#define PSR1  6 //  
;		#define CS13   3 //  
;		#define CS12   2 //  
;		#define CS11   1 //  
;		#define CS10   0 //  
;		    //    CS1		
;		    //	000			 
;		    //	001			0
;		    //	010			8
;		    //	011			64
;		    //	100			256
;		    //	101			1024
;		    //	110			  
;		    //	111			  
;
;	TCCR1B	= (0<<CTC1)|(0<<PSR1)|(0<<CS13)|(0<<CS12)|(0<<CS11)|(0<<CS10); //    1
;
;	TCNT1 = 0x00;  // 
;	OCR1A = 0x00;  //  
;	OCR1B = 0x00;  //  B
;	OCR1C = 0x00;  //  
;
;		#define PCKE  2 //   1-   
;                        //      
;                        // 1  PLLE      PLOCK  1
;		#define PLLE  1 //      
;		#define PLOCK 0 //   
;
;    PLLCSR = (0<<PCKE)|(0<< PLLE)|(0<<PLOCK);  //   
;*/
;
;    	//       
;	//************************************************************
;/*
;	//
;		#define OCIE1A  6     // / 2
;        #define OCIE1B  5     // / 1
;		#define TOIE1   2     // / 1
;		#define TOIE0   1     // / 0
;
;	TIMSK = (0<<OCIE1A)|(0<<OCIE1B)|(0<<TOIE1)|(0<<TOIE0); //    
;*/
;	//*************************************************************
;	//
;/*
;		#define OCF1A  6     // / 1
;		#define OCF1B  5     // / 1
;		#define TOV1   2     // / 1
;		#define TOV0   1     // / 0
;
;	TIFR = (0<<OCF1A)|(0<<OCF1B)|(0<<TOV1)|(0<<TOV0);//    
;*/
;	//**END***************************************************
;
;// 
;//************************************************************
;/*
;		#define WDCE   4 //    
;		#define WDE    3 //   
;		#define WDP2   2 //  
;		#define WDP1   1 //  
;		#define WDP0   0 //  
;		//  
;	   	//	000 16K
;	   	//	001 32K
;	   	//	010 64K
;	   	//	011 128K
;	   	//	100 256K
;	   	//	101 512K
;	   	//	110 1024K
;	   	//	111 2048K
;
;	WDTCR = (0<<WDCE)|(0<<WDE)|(0<<WDP2)|(0<<WDP1)|(0<<WDP0); //   
;*/
;	// **END***************************************************
;
;// 
;//*************************************************************
;/*
;
;        #define ACD    7 //  1  0 
;		#define ACBG   6 //     
;		#define ACO    5 //  ( )
;		#define ACI    4 // 
;		#define ACIE   3 // 
;		#define ACME   2 //     
;		#define ACIS1  1 //
;		#define ACIS0  0 //
;		// 				
;		//	00			 
;		//	01			
;		//	10			 1  0
;		//	11			 0  1
;*/
;	ACSR = (1<<ACD)|(0<<ACBG)|(0<<ACO)|(0<<ACI)|(0<<ACIE)|(0<<ACME)|(0<<ACIS1)|(0<<ACIS0); //   ...
	LDI  R30,LOW(128)
	OUT  0x8,R30
;
;	// **END**************************************
;
;//  
;//    
;//  
;//************************************************************
;/*
;        #define PUD 6 //      (1 -   )
;        #define SE  5 //     
;        #define SM1 4 // 
;        #define SM0 3 // 
;            // 
;            // 00       (   .   )
;            // 01        (    .)
;            // 10      (       .)
;            // 11      (    .)
;        #define ISC01    1 //  
;        #define ISC00    0 //  
;            //                  
;            //    00              
;            //    01            
;            //    10              
;            //    11              
;
;	MCUCR = (0<<PUD)|(0<<SE)|(0<<SM1)|(0<<SM0)|(0<<ISC01)|(0<<ISC00); //  
;
;		#define INT0    6 //    INT0
;		#define PCIE1   5 //     1 
;		#define PCIE0   4 //     0 
;
;	GIMSK = (0<<INT0)|(0<<PCIE1)|(0<<PCIE1);  //   
;
;
;		#define INTF0    6 //    INT0
;		#define PCIF     5 //     
;
;	GIFR = (0<<INTF0)|(0<<PCIF);  //   
;*/
;	// **END**************************************
;
;//
;//*************************************************************
;/*
;		#define REFS1  7 //   
;		#define REFS0  6 //   
;		//     REFS
;		//	00	  
;		//	01	    AREF
;		//	10	   2.25    AREF   
;		//	11 	   2.25    AREF    
;		#define ADLAR  5 //   1     0  
;		#define MUX4   4 //  
;		#define MUX3   3 //  
;		#define MUX2   2 //  
;		#define MUX1   1 //  
;		#define MUX0   0 //  
;*/
;	ADMUX = (0<<REFS1)|(0<<REFS0)|(0<<ADLAR)|(0<<MUX4)|(0<<MUX3)|(0<<MUX2)|(0<<MUX1)|(0<<MUX0); //   ...
	LDI  R30,LOW(0)
	OUT  0x7,R30
;/*
;		#define ADEN   7 //  (1  0 )
;		#define ADSC   6 //  1  
;		#define ADFR   5 //  (1   0 "" )
;		#define ADIF   4 // 
;		#define ADIE   3 // 
;		#define ADPS2  2 //  
;		#define ADPS1  1 //  
;		#define ADPS0  0 //  
;		// 	  ADPS
;		//	000		2
;		//	001		2
;		//	010		4
;		//	011		8
;		//	100		16
;		//	101		32
;		//	110		64
;		//	111		128
;*/
;	ADCSR = (1<<ADEN)|(0<<ADSC)|(0<<ADFR)|(0<<ADIF)|(0<<ADIE)|(0<<ADPS2)|(0<<ADPS1)|(0<<ADPS0); // 
	LDI  R30,LOW(128)
	OUT  0x6,R30
;	//ADCH -     
;	//ADCL -     
;
;	//**END***********************************************************
;
;//   USI
;//*************************************************************
;/*
;		#define USISIE  7 //    
;		#define USIOIE  6 //    
;		#define USIWM1  5 //  
;		#define USIWM0  4 //  
;		#define USICS1  3 //  
;		#define USICS0  2 //  
;		#define USICLK  1 //  
;        #define USITC   0 //    
;
;	USICR = (0<<USISIE)|(0<<USIOIE )|(0<<USIWM1)|(0<<USIWM0)|(0<<USICS1)|(0<<USICS0)|(0<<USICLK)|(0<<USITC); //  ...
;
;		#define USISIF   7 //   
;		#define USIOIF   6 //    
;		#define USIPF    5 //   
;		#define USIDC    4 //    
;		#define USICNT3  3 // 
;		#define USICNT2  2 // 
;		#define USICNT1  1 // 
;		#define USICNT0  0 // 
;
;	USISR = (0<<USISIF)|(0<<USIOIF)|(0<<USIPF)|(0<<USIDC)|(0<<USICNT3)|(0<<USICNT2)|(0<<USICNT1)|(0<<USICNT0); //  ...
;
;	USIDR = 0x00; // 
;*/
;	//   USI**END*************
;
;//
;//*************************************************************
;/*
;		#define EERIE 3 //   
;		#define EEMWE 2 //     (   4 )
;		#define EEWE  1 //   ( EEMWE   1)
;		#define EERE  0 //  
;
;	EECR = (0<<EERIE)|(0<<EEMWE)|(0<<EEWE)|(0<<EERE); // 
;
;	EEAR = 0x00; // 
;	EEDR = 0x00; // 
;*/
;	//**END****************************************************
;
;
;//   
;//**************************************************************
;/*
;		#define WDRF  3 //         0
;		#define BORF  2 //         0
;		#define EXTRF 1 //       0
;		#define PORF  0 //      0
;
;	MCUSR = (0<<WDRF)|(0<<BORF)|(0<<EXTRF)|(0<<PORF); //   
;*/
;	//   **END**************************************
;
;
;
;
;
;
;
;
;
;
;
;
; 0000 0018 
; 0000 0019 // 
; 0000 001A     CLI;
	cli
; 0000 001B     temp_8 = eepr_out (EEP_SAVE);                       //  
	LDI  R26,LOW(0)
	RCALL _eepr_out
	MOV  R4,R30
; 0000 001C 
; 0000 001D     if ((temp_8 < FERST_SET)||(temp_8 > 20)){           //     
	LDI  R30,LOW(9)
	CP   R4,R30
	BRLO _0x11
	LDI  R30,LOW(20)
	CP   R30,R4
	BRSH _0x10
_0x11:
; 0000 001E         eepr_in (FERST_SET, EEP_SAVE);
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R26,LOW(0)
	RCALL _eepr_in
; 0000 001F         temp_8 = FERST_SET;
	LDI  R30,LOW(9)
	MOV  R4,R30
; 0000 0020     }
; 0000 0021 
; 0000 0022     PORTA = temp_8;                                     // 
_0x10:
	OUT  0x1B,R4
; 0000 0023 
; 0000 0024 // 
; 0000 0025 while (1)
_0x13:
; 0000 0026     {
; 0000 0027         flag_bat = bat_pusch_one ();                    //   
	RCALL _bat_pusch_one
	MOV  R5,R30
; 0000 0028 
; 0000 0029         // 
; 0000 002A         if (flag_process == ON) {
	LDI  R30,LOW(1)
	CP   R30,R6
	BREQ PC+2
	RJMP _0x16
; 0000 002B             c_pausa++;                                  //    
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 8,9,30,31
; 0000 002C             // 
; 0000 002D             if (flag_bat) {
	TST  R5
	BREQ _0x17
; 0000 002E                 c_pausa = CLEAR;                        //     
	CLR  R8
	CLR  R9
; 0000 002F                 c_switch++;                             //    
	__ADDWRR 10,11,30,31
; 0000 0030                 if (c_switch >= MAX_SWITCH_OUT){        //  
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	CP   R10,R30
	CPC  R11,R31
	BRLO _0x18
; 0000 0031                     c_switch = CLEAR;
	CLR  R10
	CLR  R11
; 0000 0032                     if (PORTB.4){
	SBIS 0x18,4
	RJMP _0x19
; 0000 0033                         PORTB.4 = 0;
	CBI  0x18,4
; 0000 0034                         PORTB.3 = 1;
	SBI  0x18,3
; 0000 0035                     }
; 0000 0036                     else{
	RJMP _0x1E
_0x19:
; 0000 0037                         PORTB.3 = 0;
	CBI  0x18,3
; 0000 0038                         PORTB.4 = 1;
	SBI  0x18,4
; 0000 0039                     };
_0x1E:
; 0000 003A                     flag_out = ON;
	LDI  R30,LOW(1)
	MOV  R7,R30
; 0000 003B                 };
_0x18:
; 0000 003C             }
; 0000 003D             //   
; 0000 003E             else{
	RJMP _0x23
_0x17:
; 0000 003F                 if ((c_pausa >= IN_SWITCH)&&(c_switch)&&(flag_out == OFF)) {         //  
	LDI  R30,LOW(2600)
	LDI  R31,HIGH(2600)
	CP   R8,R30
	CPC  R9,R31
	BRLO _0x25
	MOV  R0,R10
	OR   R0,R11
	BREQ _0x25
	LDI  R30,LOW(0)
	CP   R30,R7
	BREQ _0x26
_0x25:
	RJMP _0x24
_0x26:
; 0000 0040                     c_pausa = CLEAR;                        //     
	RCALL SUBOPT_0x0
; 0000 0041                     c_switch = CLEAR;
; 0000 0042                     temp_8 = PORTB;
	IN   R4,24
; 0000 0043                     temp_8 &= 0b00000111;
	LDI  R30,LOW(7)
	AND  R4,R30
; 0000 0044                     temp_8 = (temp_8 << 1);
	LSL  R4
; 0000 0045                     if (temp_8 > 4) temp_8 = 1;
	LDI  R30,LOW(4)
	CP   R30,R4
	BRSH _0x27
	LDI  R30,LOW(1)
	MOV  R4,R30
; 0000 0046                     PORTB = (PORTB & 0b00011000)+temp_8;
_0x27:
	IN   R30,0x18
	ANDI R30,LOW(0x18)
	ADD  R30,R4
	OUT  0x18,R30
; 0000 0047                 };
_0x24:
; 0000 0048             };
_0x23:
; 0000 0049             //   
; 0000 004A             if (c_pausa >= MAX_PAUSA) {         //    
	LDI  R30,LOW(30000)
	LDI  R31,HIGH(30000)
	CP   R8,R30
	CPC  R9,R31
	BRLO _0x28
; 0000 004B                 eepr_in (PORTB, EEP_SAVE);
	IN   R30,0x18
	ST   -Y,R30
	LDI  R26,LOW(0)
	RCALL _eepr_in
; 0000 004C                 PORTA = PORTB;
	IN   R30,0x18
	OUT  0x1B,R30
; 0000 004D                 PORTB = CLEAR;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 004E                 flag_process = OFF;
	CLR  R6
; 0000 004F                 flag_out = OFF;
	CLR  R7
; 0000 0050             };
_0x28:
; 0000 0051         }
; 0000 0052         //   
; 0000 0053         else {
	RJMP _0x29
_0x16:
; 0000 0054             if (flag_bat) {
	TST  R5
	BREQ _0x2A
; 0000 0055                 flag_process = ON;
	LDI  R30,LOW(1)
	MOV  R6,R30
; 0000 0056                 PORTB = PORTA;
	IN   R30,0x1B
	OUT  0x18,R30
; 0000 0057                 PORTA = CLEAR;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0000 0058                 c_pausa = CLEAR;
	RCALL SUBOPT_0x0
; 0000 0059                 c_switch = CLEAR;
; 0000 005A             }
; 0000 005B         };
_0x2A:
_0x29:
; 0000 005C     };//END*** 
	RJMP _0x13
; 0000 005D } //END***void main(void)
_0x2B:
	RJMP _0x2B
; .FEND
;
;

	.DSEG
_flag_bat_on_S0000002000:
	.BYTE 0x1
_flag_bat_S0000002000:
	.BYTE 0x1
_schet_flag_bat_S0000002000:
	.BYTE 0x2

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	CLR  R8
	CLR  R9
	CLR  R10
	CLR  R11
	RET


	.CSEG
;END OF CODE MARKER
__END_OF_CODE:
